from edge.image.helpers import ImHelpers
from edge.types.blob import MemBlob, JsonBlobMeta
from edge.types.image import ImJpeg


class OverviewImProfile:
    def process(self, scene_dh_data: ImJpeg) -> MemBlob:
        wh = ImHelpers.get_jpeg_size2(scene_dh_data.buffer_data)
        blob_meta = JsonBlobMeta({
            'size': [wh[0], wh[1], scene_dh_data.buffer_used]
        })

        return MemBlob('overview', scene_dh_data.ts, scene_dh_data.buffer_data, blob_meta)
