from typing import Optional

from PIL import Image

from edge.image.helpers import ImHelpers
from edge.types.image import ImRgba
from edge.types.blob import MemBlob
from edge.types.shape.rect import RectF


class TrainerImProfile:
    def process(self, scene_dh_data: ImRgba, vehicle_bbox: Optional[RectF]) -> MemBlob:
        if vehicle_bbox is None:
            blob_data = ImHelpers.mk_jpeg2(scene_dh_data)
        else:
            blob_data = ImHelpers.mk_crop_resize_jpeg(
                scene_dh_data, vehicle_bbox, vehicle_bbox.fw, vehicle_bbox.fh, Image.Resampling.BICUBIC)

        return MemBlob('trainer', scene_dh_data.ts, blob_data)
