from edge.services.types.systest import SystestServiceConf, ISystestService


class _SystestService(ISystestService):
    def __init__(self, conf: SystestServiceConf) -> None:
        self._conf = conf

    @property
    def session_active(self) -> bool:
        return self._conf.session_active

    def serialize(self, jnode: dict) -> dict:
        if self._conf.cert_jnode:
            jnode.update({'certificate': self._conf.cert_jnode})

        return jnode


def init_service(conf: SystestServiceConf) -> ISystestService:
    return _SystestService(conf)
