from typing import Optional, Dict

from edge.services.types.tl import TlServiceConf


def decode__tl_service_conf(jnode: Optional[Dict]) -> Optional[TlServiceConf]:
    """
    :raise JnodeError:
    """
    if jnode is None:
        return None

    endpoint = jnode['endpoint']
    tl_ident = jnode['ref']
    red_only = jnode.get('red-only', False)
    precision_ms = jnode.get('precision-ms', 0)

    return TlServiceConf(endpoint, tl_ident, red_only, precision_ms)

