from abc import abstractmethod
from typing import Callable

from edge.services.types.service import IService


class ReactError(RuntimeError):
    pass


class IReactService(IService):
    @abstractmethod
    def set_handler(self, handler: Callable[[str, dict], None]):
        pass

    @abstractmethod
    def set_endpoints(self, endpoints: set[str]):
        pass
