import datetime

import iso8601


def datetime_to_isostr(dt: datetime.datetime, with_usecs: bool = False) -> str:
    tz_suffix = dt.strftime('%z')
    if tz_suffix == '+0000':
        tz_suffix = 'Z'

    precision = 6 if with_usecs else 3
    precision += 1
    return dt.strftime('%Y-%m-%dT%H:%M:%S') + dt.strftime('.%f')[:precision] + tz_suffix


def isostr_to_datetime_utc(isodate: str) -> datetime.datetime:
    return iso8601.parse_date(isodate)


def isostr_to_timestamp_usec(isodate: str) -> int:
    dt_utc = iso8601.parse_date(isodate)
    epoch_dt_utc = datetime.datetime.fromtimestamp(0, dt_utc.tzinfo)
    ts = 1e6 * (dt_utc - epoch_dt_utc).total_seconds()
    return int(ts)
