from typing import Final, Self


class ImageRef:
    def __init__(self,
                 ts: int | None,
                 url: str | None = None,
                 codec: str | None = None,
                 width: int | None = None,
                 height: int | None = None) -> None:

        self.ts: Final[int | None] = ts
        self.url: str | None = url  # TODO: make it final
        self.codec: Final[str | None] = codec
        self.width: Final[int | None] = width
        self.height: Final[int | None] = height

    def clone(self) -> Self:
        return ImageRef(self.ts, self.url, self.codec, self.width, self.height)

    @property
    def wh(self) -> tuple[int, int] | None:
        if None not in (self.width, self.height):
            return self.width, self.height

        raise NotImplementedError()
