from typing import List, Dict, Optional

from edge.types.trackset.le import LeTrackItem, LeTrack


def decode__le_track_item(jnode: List[int]) -> LeTrackItem:
    if len(jnode) != 2:
        raise ValueError

    min_ts, max_ts = jnode
    return LeTrackItem(min_ts, max_ts)


def decode__le_track(jnode: Dict) -> Optional[LeTrack]:
    active_jnode = jnode.get('active', [])
    ref = jnode.get('ref')
    trace = list(map(decode__le_track_item, active_jnode))
    if len(trace):
        return LeTrack(trace, ref)
