from typing import Dict

from edge.types.jnode.trackset.vrp import decode__track_vrp__raas
from edge.types.trackset.raas import RaasSceneItem, RaasScene


def decode__raas_scene_item(jnode: Dict) -> RaasSceneItem:
    """
    :param jnode:
        RaasScene#/hypos/:index
    """
    plate = decode__track_vrp__raas(jnode)
    return RaasSceneItem([plate])


def decode__raas_scene(jnode: Dict) -> RaasScene:
    """
    :param jnode:
        RaasScene#/

    :raise ValueError:
    """
    if 0 != jnode['result'] and 1 != jnode['version']:
        raise ValueError

    items = [decode__raas_scene_item(x) for x in jnode['hypos']]

    return RaasScene(items)
