from edge.types.trackset.spotspeed import SpotSpeeds, SpotSpeed


def encode__spotspeeds(value: SpotSpeeds) -> dict:
    jnode = dict()

    if value.main is not None:
        jnode['main'] = {
            'source': value.main.source,
            'measured': value.main.measured
        }

    if value.control is not None:
        jnode['control'] = {
            'source': value.control.source,
            'measured': value.control.measured
        }

    if value.ra_2 is not None:
        jnode['radar-2'] = value.ra_2

    if value.ra_n is not None:
        jnode['radar-n'] = value.ra_n

    if value.cam_2 is not None:
        jnode['camera-2'] = value.cam_2

    if value.cam_n is not None:
        jnode['camera-n'] = value.cam_n

    if value.wim is not None:
        jnode['wim'] = value.wim

    return jnode


def decode__spotspeeds(jnode: dict) -> SpotSpeeds:
    main_speed = None
    control_speed = None
    if jnode.get('main'):
        main_speed = SpotSpeed(
            source=jnode['main']['source'],
            measured=jnode['main']['measured'])

    if jnode.get('control'):
        control_speed = SpotSpeed(
            source=jnode['control']['source'],
            measured=jnode['control']['measured'])

    return SpotSpeeds(
        main_speed=main_speed,
        control_speed=control_speed,
        ra_speed_2=jnode.get('radar-2'),
        ra_speed_n=jnode.get('radar-n'),
        cam_speed_2=jnode.get('camera-2'),
        cam_speed_n=jnode.get('camera-n'),
        wim_speed=jnode.get('wim')
    )