from typing import Final


class Location:
    def __init__(self, place: str = '', lane: str = ''):
        self.place: Final[str] = place
        self._lane = lane

    @property
    def provided(self) -> bool:
        return True if len(self.place) or len(self.lane) else False

    @property
    def lane(self) -> str:
        return self._lane

    def set_lane(self, lane: str):
        self._lane = lane

