from typing import Final

from edge.types.shape.quad import QuadI

"""
Order of coordinates:
    1) from the top left corner, clockwise in the near plane
    2) from the top left corner, clockwise in the far plane
"""
type CoordsI = tuple[
    int, int, int, int,
    int, int, int, int,
    int, int, int, int,
    int, int, int, int
]


class CuboidI:
    def __init__(self, coords: CoordsI) -> None:
        self.coords: Final[CoordsI] = coords

    @property
    def near_plane(self) -> QuadI:
        return QuadI(*self.coords[:8])

    @property
    def far_plane(self) -> QuadI:
        return QuadI(*self.coords[8:])
