from typing import Final
from edge.types.trackset.vrp import TrackVrp


class RaasSceneItem:
    def __init__(self, variants: list[TrackVrp]) -> None:
        self.variants: Final[list[TrackVrp]] = variants


class RaasScene:
    def __init__(self, items: list[RaasSceneItem]) -> None:
        self.items: Final[list[RaasSceneItem]] = items

    @property
    def best_vrp_variant(self) -> TrackVrp | None:
        for item in self.items:
            max_conf_variant = max(item.variants, key=lambda v: v.text_conf)
            return max_conf_variant
