from typing import Final

from edge.types.imageref import ImageRef


class WaTrack:
    def __init__(self,
                 weight: int,
                 height: int,
                 width: int,
                 length: int,
                 lane: str,
                 event_id: int,
                 event_ts: int,
                 duration: int,
                 provider: str,
                 vrp_front: str,
                 vrp_back: str,
                 vrp_front_w: int | None,
                 vrp_back_w: int | None,
                 speed: int,
                 axle_count: int,
                 axle_layout: str,
                 vehicle_class: int,
                 road_temperature: int,
                 overview_ref: ImageRef) -> None:

        self.weight: Final[int] = weight
        self.height: Final[int] = height
        self.width: Final[int] = width
        self.length: Final[length] = length
        self.lane: Final[str] = lane
        self.event_id: Final[int] = event_id
        self.event_ts: Final[int] = event_ts
        self.duration: Final[int] = duration

        self.provider: Final[str] = provider
        self.vrp_front: Final[str] = vrp_front
        self.vrp_back: Final[str] = vrp_back

        self.vrp_front_w: Final[int | None] = vrp_front_w
        self.vrp_back_w: Final[int | None] = vrp_back_w

        self.speed: Final[int] = speed
        self.axle_count: Final[int] = axle_count
        self.axle_layout: Final[str] = axle_layout

        self.vehicle_class: Final[int] = vehicle_class
        self.road_temperature: Final[int] = road_temperature

        self.overview_ref: Final[ImageRef] = overview_ref
