from edge.support.net import query_lr_add_alarm, query_lr_get_alarm
from edge.webserver.sysconf import ph


def get_alarm(term_uuid: str, alarm_name: str) -> bool:
    term_pid = ph.map_term_uuid_to_pid(term_uuid)
    if term_pid is None:
        raise NotImplementedError

    return query_lr_get_alarm(term_pid, alarm_name)


def add_alarm(term_uuid: str, alarm_name: str) -> bool:
    term_pid = ph.map_term_uuid_to_pid(term_uuid)
    if term_pid is None:
        return False

    query_lr_add_alarm(term_pid, alarm_name)
    return True
