from edge.support import fs, net
from edge.types.identity import Identity


def create_unit__essentials__api(unit_name: str, term_ref: str) -> tuple[str, dict]:
    uiref = Identity(unit_name)
    parent_uiref = uiref.parent

    return unit_name, {
        'bundle': ['libunity_essentials', '1.0.0'],
        'type': parent_uiref.type,
        'name': parent_uiref.ref,
        'units':
        [
            {
                'type': 'api',
                'name': uiref.ref,
                'conf': {
                    'endpoint': net.get_lr_uds_endpoint(term_ref)
                }
            }
        ]
    }


def create_unit__essentials__counters(unit_name: str, spool_path: str) -> tuple[str, dict]:
    uiref = Identity(unit_name)
    parent_uiref = uiref.parent

    return unit_name, {
        'bundle': ['libunity_essentials', '1.0.0'],
        'type': parent_uiref.type,
        'name': parent_uiref.ref,
        'units':
        [
            {
                'type': 'counters',
                'name': uiref.ref,
                'conf': {
                    'stat-path': fs.join_path(spool_path, 'zabbix', 'lr0'),
                    'stat-tout': 3
                }
            }
        ]
    }
