from typing import Final

from edge.webserver.sysconf.dgmod.rn.rn_main import MainConfBuilder
from edge.webserver.sysconf.dgmod.rn.rn_setupstore import SetupStoreConfBuilder
from edge.webserver.sysconf.dgmod.rn.uiconf import IUiConfProvider2


class LocationUiConfProvider(IUiConfProvider2):
    def __init__(self, uimod_id: str, conf_path: str, uiconf: dict) -> None:
        self._uimod_id: Final[str] = uimod_id
        self._conf_path: Final[str] = conf_path
        self._uiconf: Final[dict] = uiconf

    def setup_builders(self, main_builder: MainConfBuilder, ss_builder: SetupStoreConfBuilder) -> None:
        main_builder.setup_service_cam__extrinsics(self._conf_path)
        markings_jnode: dict = self._uiconf['ro'].get('markings')
        if markings_jnode:
            main_builder.setup_image_markings__conf(markings_jnode)
