from abc import abstractmethod

from edge.webserver.sysconf.types.typeref import ITypeRefProvider, IRefProvider


class IUiConfProvider(ITypeRefProvider):
    @property
    @abstractmethod
    def lock_path(self) -> str:
        pass

    @property
    @abstractmethod
    def schema_path(self) -> str:
        pass

    @property
    @abstractmethod
    def conf_path(self) -> str:
        pass

    @abstractmethod
    def load_conf(self, **kwargs) -> dict:
        """
        :raise FsError:
        """
        pass


class IDgConfProvider(IRefProvider):
    @property
    @abstractmethod
    def conf_dir(self) -> str:
        pass
