from typing import Final

from edge.webserver.sysconf.uiconf.types.intrinsics import Intrinsics, Intrinsics2


class RtspCameraUconf:
    def __init__(self, uconf_jnode: dict) -> None:
        self._uconf_jnode: Final[dict] = uconf_jnode

    @property
    def intrinsics(self) -> Intrinsics | Intrinsics2 | None:
        ro: dict = self._uconf_jnode['ro']
        ro_value: dict | None = ro.get('intrinsic')
        if ro_value:
            return ro_value

        rw: dict = self._uconf_jnode['rw']
        rw_conf: dict = rw['conf']
        return rw_conf.get('intrinsic')
