from typing import TypedDict


Frustum = TypedDict('Frustum', {
    # The value is in pixels
    'sensor-size': tuple[int, int],
})

Frustum2 = TypedDict('Frustum2', {
    # The value is in pixels
    'sensor-size': tuple[int, int],

    # The value is in um
    'pixel-size': float,

    # The value is in mm
    'focal-dist': float
})

Calibration = TypedDict('Calibration', {
    # The value is in pixels
    'focal-dist': float,

    # Valid values are:
    #   - []
    #   - [k1, k2, p1, p2]
    #   - [k1, k2, p1, p2, k3]
    #   - [k1, k2, p1, p2, k3, k4, k5, k6]
    #   - [k1, k2, p1, p2, k3, k4, k5, k6, s1, s2, s3, s4]
    #   - [k1, k2, p1, p2, k3, k4, k5, k6, s1, s2, s3, s4, τx, τy]
    'distorsion': list[float]
})


class Intrinsics(TypedDict):
    frustum: Frustum
    calibration: Calibration


class Intrinsics2(TypedDict):
    frustum: Frustum2
