import os
from typing import Dict

from edge import eventlog
from edge.types.exceptions import JnodeError
from renderer.services.types.stats import StatsServiceConf


def decode__stats_service_conf(jnode: Dict) -> StatsServiceConf:
    """
    :param jnode:
        main.conf#/services/monitoring

    :raise JnodeError:
    """
    stat_path = jnode.get('path')
    if not (type(stat_path) in [str] and len(stat_path) < 64 and os.path.isabs(stat_path)):
        eventlog.log_e_param('#/path')
        raise JnodeError

    stat_tout_sec = jnode.get('tout')
    if not (int == type(stat_tout_sec) and 0 <= stat_tout_sec <= 255):
        eventlog.log_e_param('#/tout')
        raise JnodeError

    return StatsServiceConf(stat_path, stat_tout_sec)
