from abc import abstractmethod
from typing import Callable, Set

from edge.services.types.service import IService
from edge.types.image import ImRgba
from renderer.types.tr import TrScene


class ReactServiceConf:
    def __init__(self, endpoint: str):
        self.endpoints: Set[str] = {endpoint}


class IReactService(IService):
    @abstractmethod
    def set_handler(self, handler: Callable[[TrScene, ImRgba], None]) -> None:
        pass
