from typing import List, Self


class FaceBbox:
    def __init__(self, x0: int, y0: int, x1: int, y1: int):
        self.x0 = x0
        self.y0 = y0
        self.x1 = x1
        self.y1 = y1

    @classmethod
    def unpack(cls, jnode: List[float]) -> Self:
        if len(jnode) != 4:
            raise RuntimeError

        return cls(*jnode)


class FaceSceneItem:
    def __init__(self, face_id: int, face_conf: float, face_bbox: FaceBbox):
        self.face_id = face_id
        self.face_conf = face_conf
        self.face_bbox = face_bbox
