from typing import Dict

from edge.types.jnode.shape.quad import decode__quadi
from edge.types.jnode.shape.rect import decode__recti
from renderer.types.lr import LrSceneItem


def decode__lr_scene_item(jnode: Dict) -> LrSceneItem:
    """
    :param jnode:
        TrScene#/Lr/:index
        TrScene#/LrRa/:index/Lr
    """
    lr_plate_jnode = jnode['Plate']

    lr_oid = jnode['Id']
    lr_dir = jnode['Dir']
    lr_text = lr_plate_jnode['P']
    lr_quad = decode__quadi(lr_plate_jnode['Q'])
    lr_trace = jnode['Trace']
    vehicle_rect = None
    vehicle_rect_jnode = lr_plate_jnode.get('VR')
    if vehicle_rect_jnode:
        vehicle_rect = decode__recti(vehicle_rect_jnode)

    return LrSceneItem(lr_oid, lr_dir, lr_text, lr_quad, lr_trace, vehicle_rect)
