from typing import Dict

from edge.types.jnode.shape.cuboid import decode__cuboidi
from renderer.types.ra import RaSceneItem


def decode__ra_scene_item(jnode: Dict) -> RaSceneItem:
    """
    :param jnode:
        TrScene#/Ra/:index
        TrScene#/LrRa/:index/Ra
    """
    rel_im_x, rel_im_y = jnode['xy']
    ra_speed = int(jnode['speed'])
    ra_len = int(jnode['len'])
    ra_cuboid = decode__cuboidi(jnode['c'])
    ra_f_cm = jnode['f']
    ra_l_cm = jnode['l']

    return RaSceneItem(float(rel_im_x), float(rel_im_y), ra_speed, ra_len, ra_cuboid, ra_f_cm, ra_l_cm)
