from typing import Dict, List, Optional

from edge.image.types.builder import EventMeasImBuilderConf
from edge.types.dir import Dir

from speedcontrol.detectors.types.conf import VideoConf
from speedcontrol.events.ticket import TicketInfo
from edge.support.mask import MaskConf
from edge.types.identity import Identity


class RuleConf:
    def __init__(self, name: str, ticket: TicketInfo, footer_defvars: Dict):
        self.name = name
        self.ticket = ticket
        self.footer_defvars = footer_defvars


class DetectorConf:
    def __init__(self,
                 identity: Identity,
                 name: str,
                 store: str,
                 scene: MaskConf,
                 rules: List[RuleConf],
                 imbuilder: EventMeasImBuilderConf,
                 video: Optional[VideoConf],
                 direction: Dir,
                 on_stopbar_required: bool):

        self.identity = identity
        self.name = name
        self.store = store
        self.scene = scene
        self.rules = rules
        self.imbuilder = imbuilder
        self.video = video
        self.det_dir = direction
        self.on_stopbar_required = on_stopbar_required
