from typing import Dict

from speedcontrol.events.jnode.geoposition import encode__geoposition
from speedcontrol.events.jnode.location import encode__location
from edge.types.origin import Origin


def encode__origin(self: Origin) -> Dict:
    jnode = {
        'uuid': self.uuid,
        'time': self.time,
        'name': self.name
    }

    if self.location.provided:
        jnode['location'] = encode__location(self.location)

    if not jnode.get('geolocation') and self.geolocation:
        jnode['geolocation'] = encode__geoposition(self.geolocation)

    return jnode
