from typing import Dict

from speedcontrol.services.types.event import EventQueueConf, EventServiceConf


def decode__event_service_conf(fact_event_jnode: Dict) -> EventServiceConf:
    max_file_count = fact_event_jnode.get('max-file-count', 15)
    if not (int == type(max_file_count) and 15 <= max_file_count <= 50):
        raise ValueError('main.conf#/event-store/max-file-count')

    json_queue_args_list = [EventQueueConf(endpoint, max_file_count - 5, max_file_count)
                            for endpoint in fact_event_jnode['endpoints']]

    ua_json_required = fact_event_jnode.get('args-ua', False)
    require_plate = fact_event_jnode.get('require-plate', True)

    local_arch_base_dir = fact_event_jnode.get('local-arch-base', None)
    return EventServiceConf(require_plate, json_queue_args_list, ua_json_required, local_arch_base_dir)
