from abc import abstractmethod
from typing import Final

from edge.services.types.service import IService


class ITimekeeper(IService):
    @abstractmethod
    def test_timesync(self, min_ts: int, max_ts) -> bool:
        pass


class ChangelogConf:
    def __init__(self, max_depth_spans: int, max_depth_sec: int, span_tout_sec: float) -> None:
        self.max_depth_spans: Final[int] = max_depth_spans
        self.max_depth_usec: Final[int] = max_depth_sec * 1000000
        self.span_tout_usec: Final[int] = int(span_tout_sec * 1000000)


class ChronycConf:
    def __init__(self,
                 attempt_max_count: int,
                 attempt_interval_sec: float,
                 max_correction_sec: float,
                 max_skew_ppm: float) -> None:

        self.attempt_max_count: Final[int] = attempt_max_count
        self.attempt_interval_sec: Final[float] = attempt_interval_sec
        self.max_correction_sec: Final[float] = max_correction_sec
        self.max_skew_ppm: Final[float] = max_skew_ppm


class TimekeeperConf:
    def __init__(self, changelog: ChangelogConf, chronyc: ChronycConf) -> None:
        self.changelog: Final[ChangelogConf] = changelog
        self.chronyc: Final[ChronycConf] = chronyc
