from abc import abstractmethod
from collections.abc import Generator
from typing import Final

from edge.services.types.service import IService
from edge.types.dir import Dir


class Count:
    def __init__(self) -> None:
        self.match: int = 0
        self.unmatch: int = 0


class MatchHist:
    def __init__(self) -> None:
        self.dir_a: list[int] = [0] * 6
        self.dir_r: list[int] = [0] * 6
        self.dir_u: list[int] = [0] * 6


class TrackMatcherStats:
    def __init__(self) -> None:
        self.count = Count()
        self.match_hist = MatchHist()
        self.invalid_sender: int = 0


class LrRaMatcherConf:
    def __init__(self, match_tout_sec: int = 60) -> None:
        self.match_tout_sec: Final[int] = match_tout_sec


class ILrRaMatcher(IService):
    @abstractmethod
    def add_matches(self, lr_sender: tuple[int, int], lrra_matches: Generator[tuple[int, int], None, None]) -> None:
        pass

    @abstractmethod
    def get_ra_oids_desc(self, lr_sender: tuple[int, int], lr_dir: Dir, lr_oids: list[int]) -> list[int]:
        pass
